<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>propclass/steer.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">propclass/steer.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_PF_STEER__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PF_STEER__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;physicallayer/entity.h&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">struct </span><a class="code" href="structiPcLinearMovement.html" title="This property class controls movement of an entity in a realistic manner.">iPcLinearMovement</a>;
<a name="l00028"></a>00028 
<a name="l00067"></a><a class="code" href="structiPcSteer.html">00067</a> <span class="keyword">struct </span><a class="code" href="structiPcSteer.html" title="This is a steering property class.">iPcSteer</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   SCF_INTERFACE (<a class="code" href="structiPcSteer.html" title="This is a steering property class.">iPcSteer</a>, 1, 0, 0);
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcSteer.html#a0394f8bb7728b4a63125cf03f2b948c2" title="Stay vigilant about changes around.">Vigilant</a> () = 0;
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcSteer.html#a0bf80ce6090221e90ab193110be32996" title="Move to the specified position.">Seek</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; position) = 0;
<a name="l00088"></a>00088 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcSteer.html#a832c144d09e9e94832861e73fa97869e" title="Move away from the specified position.">Flee</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* sector, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; position) = 0;
<a name="l00099"></a>00099 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcSteer.html#a818c245703a5d6161741a869268aac22" title="Move to the specified targets position.">Pursue</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* target, <span class="keywordtype">float</span> max_prediction)=0;
<a name="l00116"></a>00116 
<a name="l00121"></a>00121   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a179522ffff7b76130865ea72f6a91a13" title="Sets arrival checking on with arrival_radius = radius.">CheckArrivalOn</a> (<span class="keywordtype">float</span> radius) = 0;
<a name="l00122"></a>00122 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a18b94aee484d097c04a55eaa72c6d01b" title="Sets arrival checking off.">CheckArrivalOff</a> () = 0;
<a name="l00127"></a>00127 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a3cc5f83c9cc7db1403ae9d0bf53191fb" title="Sets collision avoidance on.">CollisionAvoidanceOn</a> (<span class="keywordtype">float</span> lookahead, <span class="keywordtype">float</span> weight) = 0;
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a6fed0d2267e98cc8deefed6e39d0ffbf" title="Sets Collision Avoidance off.">CollisionAvoidanceOff</a> () = 0;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a45c0faec81ffa56766d44c1c78333b89" title="Sets Cohesion on.">CohesionOn</a> (<a class="code" href="structiCelEntityList.html" title="A list of entities.">iCelEntityList</a>* targets, <span class="keywordtype">float</span> radius, <span class="keywordtype">float</span> max_radius, <span class="keywordtype">float</span> weight) = 0;
<a name="l00149"></a>00149 
<a name="l00153"></a>00153   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#ab3fec35668691fe6ae05ab26f1cf6e86" title="Sets Cohesion off.">CohesionOff</a> () = 0;
<a name="l00154"></a>00154 
<a name="l00161"></a>00161   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#aa10962cc8efce907fe563dfb73539231" title="Sets Separation on.">SeparationOn</a> (<a class="code" href="structiCelEntityList.html" title="A list of entities.">iCelEntityList</a>* targets, <span class="keywordtype">float</span> radius, <span class="keywordtype">float</span> weight) = 0;
<a name="l00162"></a>00162 
<a name="l00166"></a>00166   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a58bb89b7931f71aff132c9b28a6dcaac" title="Sets Separation off.">SeparationOff</a> () = 0;
<a name="l00167"></a>00167 
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a77c535b9b4cba6cd8287f176eebd355a" title="Sets Direction Matching on.">DirectionMatchingOn</a> (<a class="code" href="structiCelEntityList.html" title="A list of entities.">iCelEntityList</a>* targets, <span class="keywordtype">float</span> weight) = 0;
<a name="l00174"></a>00174 
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#ab372a22ea5d77c4c959c6084d8a8bc09" title="Sets Direction Matching off.">DirectionMatchingOff</a> () = 0;
<a name="l00179"></a>00179 
<a name="l00184"></a>00184   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a5eb951aa306ac8dacc60529f0f6219bf" title="Interrupt a movement.">Interrupt</a> () = 0;
<a name="l00185"></a>00185 
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiSector.html">iSector</a>* <a class="code" href="structiPcSteer.html#a6c64a03ed79142641b894e4afede85d5" title="Get the end sector that we want to move to.">GetSector</a> () <span class="keyword">const</span> = 0;
<a name="l00190"></a>00190 
<a name="l00194"></a>00194   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; <a class="code" href="structiPcSteer.html#a76f68a340d625a4fc13c3c6908560968" title="Get the end position that we want to move to.">GetPosition</a> () <span class="keyword">const</span> = 0;
<a name="l00195"></a>00195 
<a name="l00199"></a>00199   <span class="keyword">virtual</span> <span class="keywordtype">float</span> <a class="code" href="structiPcSteer.html#a5a475bad4b23a3bf8afdbbbdde1b7312" title="Returns a random number using a random binomial.">RandomBinomial</a> (<span class="keywordtype">float</span> rate) = 0;
<a name="l00200"></a>00200 
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiPcSteer.html#a284fa5c89e4d1a1db57b95cd11c480aa" title="Sets current delay_recheck.">SetDelayRecheck</a> (<span class="keywordtype">int</span> delay) = 0;
<a name="l00206"></a>00206 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiPcSteer.html#a3726dbb6f2cdcbfddf00bfdf7e87922c" title="Return true if currently moving.">IsMoving</a> () <span class="keyword">const</span> = 0;
<a name="l00211"></a>00211 };
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="preprocessor">#endif // __CEL_PF_STEER__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
